---
# Get installed packages on the system
- name: Get installed packages on the system
  package_facts:
    manager: auto

# Install Wauh agent on the sensor machine
- name: Install Wazuh agent DEB
  shell:
    chdir: /tmp
    cmd: "curl -so wazuh-agent.deb https://packages.wazuh.com/3.x/apt/pool/main/w/wazuh-agent/wazuh-agent_3.11.3-1_amd64.deb && sudo WAZUH_MANAGER_IP='{{ wazuh_ip_addr }}'  dpkg -i ./wazuh-agent.deb"
  when: ansible_os_family == "Debian" and not 'wazuh-agent' in ansible_facts.packages

# Install Wauh agent on the sensor machine
- name: Install Wazuh agent RPM
  shell:
    chdir: /tmp
    cmd: "sudo WAZUH_MANAGER_IP='{{ wazuh_ip_addr }}' yum install https://packages.wazuh.com/3.x/yum/wazuh-agent-3.11.3-1.x86_64.rpm"
  when: ansible_os_family == "RedHat" and not 'wazuh-agent' in ansible_facts.packages

# Download auditbeat and filebeat agents
- name: Download the BEAT binary agents
  apt:
    deb: "{{ item }}"
  with_items:
    - "https://artifacts.elastic.co/downloads/beats/auditbeat/auditbeat-{{ siemple_version }}-amd64.deb"
    - "https://artifacts.elastic.co/downloads/beats/filebeat/filebeat-{{ siemple_version }}-amd64.deb"
  when: ansible_os_family == "Debian" and ( not 'filebeat' in ansible_facts.packages or not 'auditbeat' in ansible_facts.packages )
  register: installed_packages

# Download auditbeat and filebeat agents
- name: Download the BEAT binary agents
  get_url:
    url: "https://artifacts.elastic.co/downloads/beats/auditbeat/auditbeat-{{ siemple_version }}-x86_64.rpm"
    dest: "/tmp/auditbeat-{{ siemple_version }}-x86_64.rpm"
  when: ansible_os_family == "RedHat"

# Deploy BEATS configuration files
- name: Deploy BEAT configuration files
  template:
    src: "{{ item.src }}"
    dest: "{{ item.dest }}"
  with_items:
    - { src: "{{ role_path }}/templates/agents/auditbeat.yml.j2" , dest: "/etc/auditbeat/auditbeat.yml" }
    - { src: "{{ role_path }}/templates/agents/filebeat.yml.j2" , dest: "/etc/filebeat/filebeat.yml" }

# Enable and start BEATs
- name: Enable and start beat agents
  service:
    name: "{{ item }}"
    state: started
    enabled: yes
  with_items:
    - "filebeat"
    - "auditbeat"
